import akka.actor.*;

public class StockCollector extends UntypedActor {
  private final long start = System.nanoTime();
  private int receivedResponse = 0;
  private int maxExpectedResponse = Integer.MAX_VALUE;
  private StockInfo highest = new StockInfo("", 0.0);
  
  public void onReceive(final Object message) {
    if(message instanceof Integer) {
      maxExpectedResponse = ((Integer)(message)).intValue();
    } else {
      receivedResponse++;
      
      StockInfo stockInfo = (StockInfo) message;
      if (stockInfo.price > highest.price)
        highest = stockInfo;
        
      if(receivedResponse == maxExpectedResponse) {
        final long end = System.nanoTime();
        System.out.println(highest);
        System.out.println("Time: " + (end - start)/1.0e9);
        getContext().system().shutdown();
      }
    }
  }
}